<template>
  <div>
    <BToastOrchestrator />
  </div>
</template>

<script lang="ts">
import useNotificationStore from "@/store/notification";
import useLoginStore from "@/modules/login/store";

import type {
  NotificationToast,
  NotificationTranslationProps,
} from "@/store/types";
import { Translation } from "vue-i18n";
import { BToast, useToast } from "bootstrap-vue-next";

export default defineComponent({
  setup() {
    const notificationStore = useNotificationStore();
    const loginStore = useLoginStore();
    const toastController = useToast();

    return { notificationStore, loginStore, toastController };
  },

  computed: {
    isSessionExpired(): boolean | null {
      return !this.loginStore.isLoggedIn;
    },
    currentToast(): NotificationToast | undefined {
      return this.notificationStore.notificationQueue
        ? this.notificationStore.notificationQueue.at(0)
        : undefined;
    },
  },

  watch: {
    currentToast() {
      const toast = this.currentToast;
      if (toast) {
        // Display the notification toast.
        // Prevent the creation of notification toasts when the session is expired.
        // Such cases are handled by the ExpiryToast element.
        if (this.isSessionExpired !== null && !this.isSessionExpired) {
          this.makeToast(toast);
        }
        // Toast has been shown, remove it from the queue
        this.notificationStore.deleteNotification(toast);
      }
    },
  },

  methods: {
    async makeToast(toast: NotificationToast) {
      let toastComponent: VNode | undefined;
      if (!toast.pos) {
        toast.pos = "bottom-end";
      }

      // Build the toast body from the i18n options object
      if (toast.component) {
        const options: NotificationTranslationProps = toast.component;
        const placeholders = options.placeholders || {};

        const childNodes = Object.fromEntries(
          Object.entries(placeholders).map(([k, v]) => [
            k,
            () => h(v.el, { class: v.class }, v.value),
          ]),
        );
        toastComponent = h(BToast, null, {
          default: () =>
            h(
              Translation,
              { keypath: options.keypath, tag: options.tag },
              childNodes,
            ),
        });
      }

      if (toast.autoHide === false) {
        toast.value = Number.MAX_VALUE;
      }

      this.toastController.show?.({
        props: () => toast,
        component: toastComponent,
      });
    },
  },
});
</script>
